# FG004_A(Test Mode)

## Description

This embedded firmware is the testing mode for the triac software.

It causes the attiny404 to generate pulses continuously, which are delayed
by a value configured in the `config.h` file.

The timing is done after the PZC(positive zero crossing) of the AC input 
waveform.

### Micro Controller Pins

**ATtiny404**

1. VDD(+5v)
2. PA4(ADC_LOAD1)
3. PA5(ADC_LOAD2)
4. PA6(ADC_LOAD3)
5. PA7(zerocrossing)
6. PB3(G2)
7. PB2(G3)
8. PB1(SDA)
9. PB0(SCL)
10. RST(NC)
11. PA1(G1)
12. PA2(NC)
13. PA3(NC)
14. VSS(GND)

*key*
NC:: Not Connected
PBX:: Port B pin X
PAX:: Port A pin X
RST:: Reset pin


## Project Layout

Documentation that has been generated is inside the docs folder which contains
the html output that can be browswed via your regular web browser.

PDF genreation from the doumentaiton is also possible if enabled through the
`Doxyfile` inside the projects root directory.


## Build Requirements

- AVR-GCC toolchain OR XC8 from microchip.
- Make OR CMAKE
- avrdude
- A AVR programmer, usbasp for older chips and UPDI for newer ones.


## Dev Requirements

- ATtiny404 series micro-controller
- AVR-GCC toolchain.
- Cmake
- cpputest(Unit testing harness.)
- Doxygen(For documentation) 
- Git(For version control)
